schema_name   : args
schema_version: 1.0
schema_type   : peripheral

hdl_library_name       : HBM_PktController
hdl_library_description: "HBM_PktController configuration"

peripherals:

  - peripheral_name        : HBM_PktController
    peripheral_description : "HBM_PktController Configuration"

    slave_ports:
      - slave_name        : config
        slave_type        : reg
        number_of_slaves  : 1
        slave_description : "HBM_PktController control"
        fields:
          - - field_name        : tx_enable #Start_Stop_TX 
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Start or stop the HBM_PktController."

          - - field_name        : tx_reset 
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Reset the tx SMs and logic in the HBM controller. Other variables for TX should be update while this is held high."

          - - field_name        : tx_running #running
              width             : 1
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Hardware feedback of tx_enable"  
              
          - - field_name        : tx_loop_enable #loop_tx
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "1: Loop traffic"

          - - field_name        : tx_looping #looping
              width             : 1
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Looping is running"

          - - field_name        : tx_loops #expected_number_of_loops
              width             : 32
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Number of loops to do"
            
          - - field_name        : tx_loop_count #loop_cnt
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Current status (number) of the loop counter"
         ##################################################################    
          - - field_name        : tx_header_update #Inplace_Header_Update
              width             : 8
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Select the data path post HBM playout, 0 : HBM -> 100G, 1 : HBM -> CODIF update logic -> 100G)
                                   Set this before setting tx_enable to 1."
         ##################################################################    
          - - field_name        : tx_codif_header_packets_per_frame
              width             : 32
              access_mode       : RW
              reset_value       : 0x0
              field_description : "For updating the counters this is (number of jimbles * channels) parameter"
         ##################################################################    
          - - field_name        : tx_codif_header_packets_epoch_offset
              width             : 32
              access_mode       : RW
              reset_value       : 0x0
              field_description : "For example, set to 27 for CODIF"
         ##################################################################    
          - - field_name        : tx_codif_header_frame_initial_value
              width             : 32
              access_mode       : RW
              reset_value       : 0x0
              field_description : "frame_initial_value"
         ##################################################################    
          - - field_name        : tx_packet_type #Packet_Type  .... NOT USED
              width             : 4
              access_mode       : RW
              reset_value       : 0x0
              field_description : "0 :RAW pcap (full ethernet packet), 2: SPEAD pcap, 3 CODIF pcap"

          - - field_name        : tx_packet_size #Packet_Size
              width             : 32
              access_mode       : RW
              reset_value       : 0x0
              field_description : "size of the complete packet including ethernet header, spead header etc"

          - - field_name        : tx_packet_to_send #Total_Number_TX_Packets
              width             : 32
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Total number of TX packets to play out"

          - - field_name        : tx_burst_gap #Time_Between_Bursts_ns
              width             : 32
              access_mode       : RW
              reset_value       : 0x0
              field_description : "time in ns between start of packets"

          - - field_name        : tx_axi_transactions #expected_total_number_of_4k_axi
              width             : 32
              access_mode       : RW
              reset_value       : 0x00
              field_description : "Total number of HBM RDs required = tx_total_number_TX_packets x (ceil(tx_packet_size/64))"

          - - field_name        : tx_axi_transaction_count #current_axi_4k_count 
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "current number of AXI transactions for tx since reset"

          - - field_name        : tx_burst_packets #Number_of_Packets_in_Burst  .... NOT USED!!!
              width             : 32
              access_mode       : RW
              reset_value       : 0x00
              field_description : "Number of packets to send back-to-back"
        
          - - field_name        : tx_packets_per_burst #expected_packets_per_burst
              width             : 32
              access_mode       : RW
              reset_value       : 0x01
              field_description : "This is a parameter for how much data the FIFO in HBM controller caches before sending. Harcode to 1 currently."

          - - field_name        : tx_bursts #expected_total_number_of_bursts
              width             : 32
              access_mode       : RW
              reset_value       : 0x00
              field_description : "From above this will be (tx_total_number_TX_packets / packets per burst), so current will also = tx_total_number_TX_packets "
         
          - - field_name        : tx_beats_per_packet #expected_beats_per_packet
              width             : 32
              access_mode       : RW
              reset_value       : 0x00
              field_description : "Beat is an AXI transfer (512 bit width), number of beats per packet = tx_packet_size / 64"
       
          - - field_name        : tx_beats_per_burst #expected_number_beats_per_burst
              width             : 32
              access_mode       : RW
              reset_value       : 0x00
              field_description : "From above will be 1 x tx_beats_per_packet"
 
          - - field_name        : tx_burst_count #burst_count
              width             : 32
              access_mode       : RO
              reset_value       : 0x00
              field_description : "current burst_count value, ie progress to tx_bursts"
         ##################################################################    
          - - field_name        : tx_packet_count_hi #current_pkt_count_high
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "number of packets read out of fifo upper 32 bits of 64 bit counter, current loop"
         #################################
          - - field_name        : tx_packet_count_lo #current_pkt_count_low
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "number of packets read out of fifo lower 32 bits of 64 bit counter, current loop"
         ##################################################################
          - - field_name        : tx_packets_to_mac_hi #total_pkts_to_mac_high
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "count of the total number of packets sent to the 100G MAC, upper 32 bits of 64 bit counter"
         #################################
          - - field_name        : tx_packets_to_mac_lo #total_pkts_to_mac_low
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "count of the total number of packets sent to the 100G MAC, lower 32 bits of 64 bit counter"
         #################################
          - - field_name        : tx_complete
              width             : 1
              access_mode       : RO
              reset_value       : 0x0
              field_description : "tx_complete"
         #################################
          - - field_name        : tx_use_packet_timestamp_to_tx
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Use the 80 bit number packed into the meta data of each packet in the HBM to govern playout"
            ######### DEBUG SIGNALS
          - - field_name        : debug_tx_current_hbm_rd_addr 
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "current_hbm_rd_addr"

          - - field_name        : debug_tx_current_hbm_rd_buffer 
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "current HBM bank, 0 1 2 or 3"

          - - field_name        : debug_tx_total_packet_beat_count #total_beat_count  NOT USED
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Total rd signals sent to FIFO sending to packet_player"

          - - field_name        : debug_tx_packet_beat_count # beat_count   NOT USED
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "How many rd signals the current packet sending, to the FIFO sending to packet_player"

          - - field_name        : debug_tx_burst_packet_count #fpga_pkt_count_in_this_burst     NOT USED
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "current count in a burst" 
         #################################
          - - field_name        : debug_rd_fsm_debug
              width             : 8
              access_mode       : RO
              reset_value       : 0x0
              field_description : "rd_fsm_debug, the current state of the RD request to HBM StateMachine"
         #################################
          - - field_name        : debug_output_fsm_debug
              width             : 8
              access_mode       : RO
              reset_value       : 0x0
              field_description : "output_fsm_debug, the current state of the Send packet to 100G StateMachine"
         #################################
          - - field_name        : debug_input_fsm_debug
              width             : 8
              access_mode       : RO
              reset_value       : 0x0
              field_description : "input_fsm_debug, the current state of the RX StateMachine between data from CMAC and HBM"
         #################################
          - - field_name        : debug_FIFO_DataCount      # NOT USED
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Read and Write counts from the FIFO cache in HBM controller holding the data from HBM before sending to CMAC"      
         #################################
          - - field_name        : debug_capture_filter_target
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Number of target packets to make it past filter and to the HBM"      
         #################################
          - - field_name        : debug_capture_filter_non_target
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Number of target packets to not make it past filter and to the HBM"      

          - - field_name        : ns_total_time
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "current time since start of running in ns"
               
          - - field_name        : ns_burst_timer
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "timer used to determine when to send the next burst of packets"
         
         ############# RX Register Section
          - - field_name        : rx_packet_size
              width             : 32
              access_mode       : RW
              reset_value       : 0x0
              field_description : "byte count of packet we want to capture"
         #################################
          - - field_name        : rx_reset_capture
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "reset capture logic chain"
         #################################
          - - field_name        : rx_reset_counter
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "reset capture logic stats"
         #################################
          - - field_name        : rx_enable_capture
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "rx capture logic enable"
         #################################
          - - field_name        : rx_hbm_1_end_addr # rx_1st_4GB_rx_addr
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "HBM #1 end of data address"
         #################################
          - - field_name        : rx_hbm_2_end_addr # rx_2nd_4GB_rx_addr
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "HBM #2 end of data address"
         #################################
          - - field_name        : rx_hbm_3_end_addr # rx_3rd_4GB_rx_addr
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "HBM #3 end of data address"
         #################################
          - - field_name        : rx_hbm_4_end_addr #rx_4th_4GB_rx_addr
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "HBM #4 end of data address"
         #################################
          - - field_name        : rx_packets_to_capture #
              width             : 32
              access_mode       : RW
              reset_value       : 0x0000FFFF
              field_description : "Number of packets to capture before stopping."
         #################################
          - - field_name        : rx_complete # 
              width             : 1
              access_mode       : RO
              reset_value       : 0x0
              field_description : "capture full"
         #################################
          - - field_name        : rx_packet_count_hi 
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Total number of captured packets upper 32 bits of 64"              
         #################################
          - - field_name        : rx_packet_count_lo 
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Total number of captured packets lower 32 bits of 64"  
         #################################
          - - field_name        : rx_bank_enable #
              width             : 8
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set 1 to disable the bank, Bit 0 will enable capture for the first buffer, 1 for the second, etc. For full 16GB set to 0x0, for 8GB starting in 3rd buffer set to 0x3, defaulting to all banks enable."
         #################################
          - - field_name        : rx_flush_to_hbm
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set 1 to flush RX fifo to HBM, and will need to be set back to 0. This is used when the number of RX packets is unknown and will leave the CNIC RX in a dirty state until next capture is configured"              
         #################################
          - - field_name        : rx_packet_size_abs
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set to 0, this will set the capture filter to use the rx_packet size as a minimum value, set to 1 it will only capture the stipulated size"
         #################################
          - - field_name        : enable_duplex
              width             : 4
              access_mode       : RW
              reset_value       : 0x0
              field_description : "This register controls how the four HBM interfaces are assigned to RX or TX.
                                   0 - Card will either TX or RX for the full HBM, 
                                   1 - Card will assign the first 2 buffers to RX and the last 2 to TX,
                                   2 - Card will assign the first 1 buffers to RX and the last 3 to TX,
                                   3 - Card will assign the first 3 buffers to RX and the last 1 to TX."
         #################################
          - - field_name        : legacy_rate_sel
              width             : 1
              access_mode       : RW
              reset_value       : 0x1
              field_description : "Set to 1 to use 100 MHz internal timer, set to 0 to use PTP driven timer."
         #################################
          - - field_name        : loopback_sel
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set to 1 to echo out on the TX interface what is Received on RX.
                                   Beware use with PTP.
                                   Only available on primary 100G for dual 100G cards, not available in U280 builds."